<?php
/*
Plugin Name: Ezyway Mobiversa
Plugin URI: https://ocs.mobiversa.com/Product/EZYWAY
Description: One Touch Online Payment Gateway Plugin for Malaysia. Give your customers the best user experience with your own UI/UX with Mobiversa’s Online Payment Gateway. Above all get your payments settled to your business bank account in Malaysia in 2 working days.
Version: 1.0.0
 Author:            Mobiversa
 Author URI:        https://www.mobiversa.com
 Text Domain:       Ezyway Mobiversa
*/

add_action('admin_menu', function(){
    add_options_page('Ezyway Mobiversa Payment', 'Ezyway Mobiversa', 'manage_options', 'ezyway-mobiversa-payment', 'ezyway_mobiversa_payment');
});

add_action('admin_init', function(){
    register_setting('ezyway-mobiversa-payment', 'paymentMode'); 
    register_setting('ezyway-mobiversa-payment', 'apiKey');
    register_setting('ezyway-mobiversa-payment', 'loginID');
});
 
function ezyway_mobiversa_payment()
{
  ?>  
    <div class="wrap">
      <h3>Mobiversa Payment Configuration</h3>		
      <form action="options.php" method="post">
        <?php
          settings_fields('ezyway-mobiversa-payment');
          do_settings_sections('ezyway-mobiversa-payment'); 
        ?>
        <table class="form-table">
            <tr class="forminp">
                <th>Payment Mode</th>
                <td>
                    <select style="width:300px;" name="paymentMode" class="select">
                        <option value="sandbox" <?php echo esc_attr(get_option('paymentMode')) == 'sandbox' ? 'selected="selected"' : ''; ?>>Sandbox</option>
                        <option value="live" <?php echo esc_attr(get_option('paymentMode')) == 'live' ? 'selected="selected"' : ''; ?>>Live</option>
                    </select>
                </td>
            </tr>
            <tr class="forminp">
                <th>Mobiversa API Key</th>
                <td><input style="width:300px;" type="text" placeholder="Mobiversa API Key" name="apiKey" value="<?php echo esc_attr(get_option('apiKey')); ?>" /></td>
            </tr>
            <tr class="forminp">
                <th>Merchant Login ID</th>
                <td><input style="width:300px;" type="text" placeholder="Merchant Login ID" name="loginID" value="<?php echo esc_attr(get_option('loginID')); ?>" /></td> 
            </tr>
 
            <tr class="forminp">
                <td><?php submit_button(); ?></td>
            </tr>
        </table>
      </form>
    </div>
  <?php
}
    

function ezymobiForm()
{
    echo '
        <label>
        Pay by Mobiversa (Credit/Debit Card) <img src="'.WP_PLUGIN_URL . "/" . plugin_basename(dirname(__FILE__)) . '/mobiversa.png'.'" alt="Pay by Mobiversa (Credit/Debit Card)" style="float:right;"> 
        </label>    
        <form action="'.esc_url('http'.(empty($_SERVER['HTTPS'])?'':'s').'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'" method="post">  
            <div class="row clearfix">   
                <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">Email Address <span class="req">*</span></div>
                    <input type="email" name="CardEmail" id="CardEmail" required placeholder="Email Address">
                </div> 

                 <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">Card Name <span class="req">*</span></div>
                    <input type="text" name="nameOnCard" id="nameOnCard" required placeholder="Card Name">
                </div>
                
                <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">Card Number <span class="req">*</span></div>
                    <input type="text" name="CardNum" id="CardNum" required placeholder="Card Number">
                </div>                            

                <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">CCV <span class="req" required>*</span></div>
                    <input style="width:55px;" type="password" maxlength="3" name="CCV" id="CCV" required placeholder="123">
                </div>
                
                <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">ExpDate  <span class="req">*</span></div>
                    <input type="text" maxlength="2" style="width:57px; float:left; margin-right:10px;" name="ExpDateM" id="ExpDateM" required placeholder="MM">
                    <input type="text" maxlength="4" style="width:70px;" name="ExpDateY" id="ExpDateY" required placeholder="YYYY">
                </div>

                <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">Total Product Price <span class="req" required>*</span></div>
                    <input type="text" name="ProductP" id="ProductP" required placeholder="Product Price">
                </div> 

                 <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label">Order ID<span class="req" required>*</span></div>
                    <input type="text" name="OrderID" id="OrderID" required placeholder="Order ID">
                </div>               

                <div class="form-group col-md-6 col-sm-6 col-xs-12">
                    <div class="field-label"> &nbsp; </div>
                    <input type="submit" name="submit" value="Submit">
                </div>
            </div>
        </form>
    ';

    if(isset($_POST['PaRes']))
    {
        $data=array("service"=>"ECOMAPI_SALE_3DSREQ", "trackid"=>get_option('trackid'), "paRes"=>sanitize_text_field($_POST['PaRes']), "carddetails"=>get_option('carddetails'));

        $headers = array('content-type'=>'application/json', 'mobiApiKey'=>get_option('apiKey'), 'loginId'=>get_option('loginID'));

        $reqArr = array('body'=>json_encode($data), 'timeout'=>'250', 'redirection'=>'5', 'httpversion'=>'1.0', 'blocking'=>true, 'headers'=>$headers, 'cookies'=>array());    

        $server_output = wp_remote_post(get_option('payMode'), $reqArr);   

        if(is_wp_error($response)) 
        {            
            echo "<h2>". esc_html('Server error'). "</h2>";
        }         
        else 
        {
            $fresult=json_decode($server_output["body"], true);                
            if($fresult['responseMessage']=='SUCCESSFUL')
            {             
                echo "<script>alert('".esc_html('Your payment successfully accepted!')."');</script>"; 
            }
            else 
            {
                echo "<script>alert('".esc_html($fresult['responseDescription'])."');</script>";
            }
        }
        
    }
}


function ezyway_mobiversa_payform(){
    global $CardEmail, $nameOnCard, $CardNum, $ccv, $ExpDateM, $ExpDateY, $ProductP, $OrderID;

    if(get_option('paymentMode') == 'sandbox'){$payMode='https://demo.mobiversa.com/payment/myapiservice/jsonservice';}
    else if(get_option('paymentMode') == 'live'){$payMode='https://pay.mobiversa.com/payment/myapiservice/jsonservice';}

    $pass = $CardNum.'#'.$ccv.'#'.substr($ExpDateY, -2).$ExpDateM;
    $encrypted = base64_encode(openssl_encrypt($pass, 'aes-128-cbc', substr(get_option('apiKey'), 0, 16), OPENSSL_RAW_DATA, substr(get_option('apiKey'), -16)));

    $chckAmount=is_numeric($ProductP) && floor($ProductP) != $ProductP;
    $am = $ProductP;
    if($am !='')
    {        
        if($chckAmount==1)
        {
            $s2 = str_replace(".","", number_format($am, 2, '.', ''));
            $s3 = strlen($s2);  
            $f1 = 12 - $s3;
            $amt1 = "";
            for($i=0; $i<$f1; $i++)
            {
                $amt1 .= "0";  
            }
            $famt = $amt1.$s2;
        }
        else 
        {
            $str='000000000000';
            $finalStr=substr($str, strlen(round($am))+2);
            $famt = $finalStr.round($am).'00';
        }   
    }
    else 
    {
         $famt = '000000000000';
    }

    $data=array("service"=>"ECOMAPI_SALE_REQ", "orderId"=>$OrderID, "amount"=>$famt, "email"=>$CardEmail, "carddetails"=>strtoupper(implode(unpack("H*", $encrypted))));
   
    if(get_option('carddetails')){ update_option('carddetails', strtoupper(implode(unpack("H*", $encrypted)))); }
    else { add_option('carddetails', strtoupper(implode(unpack("H*", $encrypted)))); }

    if(get_option('payMode')){ update_option('payMode', $payMode); }
    else { add_option('payMode', $payMode); }

    $headers = array('content-type'=>'application/json', 'mobiApiKey'=>get_option('apiKey'), 'loginId'=>get_option('loginID'));

    $reqArr = array('body'=>json_encode($data), 'timeout'=>'250', 'redirection'=>'5', 'httpversion'=>'1.0', 'blocking'=>true, 'headers'=>$headers, 'cookies'=>array());    

    $server_output = wp_remote_post($payMode, $reqArr);            

    $fresult=json_decode($server_output["body"], true);
    
    if($fresult['responseData']['paReq']!='')
    {
        if(get_option('trackid')){ update_option('trackid', $fresult['responseData']['trackid']); }
        else { add_option('trackid', $fresult['responseData']['trackid']); }

        echo '<form name="Payer" id="Payer" action="'.esc_url($fresult['responseData']['url']).'" method="post">
                <input type="hidden" name="PaReq" value="'.$fresult['responseData']['paReq'].'"/>
                <input type="hidden" name="TermUrl" id="TermUrl" value="'.esc_url('http'.(empty($_SERVER['HTTPS'])?'':'s').'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'"/>
                <input type="hidden" name="MD" value="'.$fresult['responseData']['trackid'].'"/>
                </form>
                <script>document.getElementById("Payer").submit();</script>
                ';
    }
    else if($fresult['responseCode']=='0001')
    {            
        echo "<script>alert('".esc_html($fresult['responseDescription'])."');</script>";
    }
}


function ezyway_mobiversa_shortcode(){
    if(isset($_POST['submit']))
    {      
        global $CardEmail, $nameOnCard, $CardNum, $ccv, $ExpDateM, $ExpDateY, $ProductP, $OrderID;

        $CardEmail = sanitize_email($_POST['CardEmail']);
        $nameOnCard = sanitize_text_field($_POST['nameOnCard']);
        $CardNum = sanitize_text_field($_POST['CardNum']);        
        $ccv = sanitize_text_field($_POST['ccv']);
        $ExpDateM = sanitize_text_field($_POST['ExpDateM']);
        $ExpDateY = sanitize_text_field($_POST['ExpDateY']);
        $ProductP = sanitize_text_field($_POST['ProductP']);
        $OrderID = sanitize_text_field($_POST['OrderID']);
        
        ezyway_mobiversa_payform(
            $CardEmail,
            $nameOnCard,
            $CardNum,
            $ccv,
            $ExpDateM,
            $ExpDateY,
            $ProductP,
            $OrderID
        );
    }     
    ezymobiForm();    
}


add_shortcode('ezyway_mobiversa', 'mobiversa_payform_shortcode');
 
function mobiversa_payform_shortcode() 
{
    ob_start();
    ezyway_mobiversa_shortcode();
    return ob_get_clean();
}


//Nafees